;; -*- geiser-scheme-implementation: guile -*-

;; grid.scm - This file is part of Guile TD
;; Copyright (C) 2017  Christopher Howard

;; Guile TD is free software: you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.

;; Guile TD is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;; General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.

(define-module (td grid)
  :use-module (aa-tree)
  :export (grid-coords
           center-coords
           set-block))

(define (grid-coords block-width x y)
  (let ((row (floor-quotient y block-width))
        (col (floor-quotient x block-width)))
    (list col row)))

(define (center-coords block-width x y)
  (map (lambda (n)
         (+ (* n block-width)
            (quotient block-width 2)))
       (grid-coords block-width x y)))

(define (set-block tower-grid grid-coords value)
  (aa-insert #nil grid-coords value))

